//for random number generator
#include <stdlib.h>
#include <time.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "export.h"
#include <stdio.h>
#include <string.h>

//for xml
#include <libxml/xmlreader.h>
#include <libxml/encoding.h>
#include <libxml/xmlwriter.h>


     #include <htmllite/htmlcallbacks.h>
     #include <htmllite/htmlinterface.h>
     #include <htmllite/htmlbuffer.h>

#define MY_ENCODING "UTF-8"
//TODO: Get rid of all char assignments and set to standard gnome practices
static gchar *current_filename;
static gboolean AnswerasQuestion = TRUE;

static int
read_ignore_whitespace(xmlTextReaderPtr reader)
{
 int ret = 1;
 ret = xmlTextReaderRead(reader);
 if(xmlTextReaderNodeType(reader) == XML_READER_TYPE_SIGNIFICANT_WHITESPACE )
 {
     read_ignore_whitespace(reader);
 }
 return ret;                  
}

static gchar 
*question_size(gchar *question_string)
{
   int len = g_strv_length((gchar **)question_string);
   const gchar relative_size[15];
   printf("ok3\n");
   if(len > 40)
   {
       g_sprintf(relative_size, "medium");
   }
   else if (len > 60)
   {
       g_sprintf(relative_size, "small");
   }
   else
   {
       g_sprintf(relative_size, "large");
   }
   
   return g_strdup(relative_size);
}

static void
byoj_show_board(GtkWidget *widget)
{
	//this should just make the board visible
	GtkWidget *table = lookup_widget(widget, "table1");
	GtkWidget *image1 = lookup_widget(widget, "image1");
	GtkWidget *hboxTreeview = lookup_widget(widget, "hboxTreeview");		
	gtk_widget_hide (image1);
	gtk_widget_hide (hboxTreeview);
	gtk_widget_show (table);
}

static gboolean
processNode(xmlTextReaderPtr reader, GtkTreeModel *store) 
{
	const xmlChar *name, *value;
//TODO:Test reading with errors in code
	name = xmlTextReaderConstName(reader);
	if (name == NULL)
		name = BAD_CAST "--";
	
	value = xmlTextReaderConstValue(reader);

	if(!xmlStrcasecmp(name, (const xmlChar*)"topic") && xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT)
	{
		GtkTreeIter piter;
		gtk_tree_store_append (GTK_TREE_STORE(store), &piter, NULL);
		
		int ret = 1;
		while (ret==1)
		{
              ret = read_ignore_whitespace(reader);
              name = xmlTextReaderConstName(reader);
		if(!xmlStrcasecmp(name, (const xmlChar*)"topic_name") &&   xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT)
		{
             ret = read_ignore_whitespace(reader);
			value = xmlTextReaderConstValue(reader);
			if(value == NULL  && ret < 1)
			{
                         printf("Error opening file: Unable to read topic\n");
			 return FALSE;
             }
			if(xmlStrcasecmp(name, (const xmlChar*)"Daily Double")!=0)
			{
				gtk_tree_store_set (GTK_TREE_STORE(store), &piter,
						0, value,
						1, TRUE,
						-1);
			}
			else
			{
				gtk_tree_store_set (GTK_TREE_STORE(store), &piter,
						0, value,
						1, FALSE,
						-1);	
			}
			printf("Added Topic: %s\n", value);
			
		}
		
        ret = read_ignore_whitespace(reader);
        ret = read_ignore_whitespace(reader);
		name = xmlTextReaderConstName(reader);
        while(ret==1)
        {

		if(!xmlStrcasecmp(name, (const xmlChar*)"value") && xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT)
		{
			GtkTreeIter citer, question_iter, answer_iter;
			gtk_tree_store_append (GTK_TREE_STORE(store), &citer, &piter);  /* Acquire an iterator */
			gtk_tree_store_append (GTK_TREE_STORE(store), &question_iter, &citer);  /* Acquire an iterator */
			gtk_tree_store_append (GTK_TREE_STORE(store), &answer_iter, &citer);  /* Acquire an iterator */
			
			int value_node = 1;
			//gchar *value_str, *question_str, *answer_str;
			value_node = read_ignore_whitespace(reader);
			while (value_node==1)
			{
                  name = xmlTextReaderConstName(reader);
                  value_node = read_ignore_whitespace(reader);
			      value = xmlTextReaderConstValue(reader);
			      printf("value:%s\n", value);
			      if(value == NULL  && value_node < 1)
			      {
                         printf("Error opening file: Unable to read value\n");
			 return FALSE;
                         }
			
				printf("trying to add:%s\n", name);
				if(!xmlStrcasecmp(name, (const xmlChar*)"amount") &&   xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT )
				{
                    //value_node =  g_strdup((gchar *)node_str);
					gtk_tree_store_set (GTK_TREE_STORE(store), &citer,
							0, value,
							1, TRUE,
							-1);
					printf("Added amount: %s\n", value);
				}
				if(!xmlStrcasecmp(name, (const xmlChar*)"question") &&   xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT )
				{
					//question_str = g_strdup(node_str);
					gtk_tree_store_set (GTK_TREE_STORE(store), &question_iter,
							2, value,
							3, TRUE,
							-1);
					printf("Added question: %s\n", value);
				}
				if (!xmlStrcasecmp(name, (const xmlChar*)"answer") &&   xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT )
				{
					//answer_str = g_strdup(node_str);
					gtk_tree_store_set (GTK_TREE_STORE(store), &answer_iter,
							2, value,
							3, TRUE,
							-1);
					printf("Added answer: %s\n", value);
				}
			
				value_node = read_ignore_whitespace(reader);
				value_node = read_ignore_whitespace(reader);
				name = xmlTextReaderConstName(reader);
				printf("trying to process:%s\n", name);
				if (name == NULL)
				{
					name = BAD_CAST "--";
				}
				value = xmlTextReaderConstValue(reader);
				if(!xmlStrcasecmp(name, (const xmlChar*)"value") && xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT)
				{
					value_node=0;
				}
			}
			//add_question(GTK_TREE_STORE(store), piter, value_str, question_str, answer_str);

			printf("leaving value while\n");
		}			
		    ret  = read_ignore_whitespace(reader);
			name = xmlTextReaderConstName(reader);
			if (name == NULL)
			{
				name = BAD_CAST "--";
			}
			if(!xmlStrcasecmp(name, (const xmlChar*)"topic") && xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT)
			{
				ret=0;
			}
        }
        }
		printf("leaving while\n");
		
	}
	
	printf("%d %d %s %d %d", 
	xmlTextReaderDepth(reader),
	xmlTextReaderNodeType(reader),
	name,
	xmlTextReaderIsEmptyElement(reader),
	xmlTextReaderHasValue(reader));
	if (value == NULL)
		printf("\n");
	else {
		if (xmlStrlen(value) > 40)
			printf(" %.40s...\n", value);
		else
			printf(" %s\n", value);
	}
	return TRUE;
}

/**
* streamFile:
		* @filename: the file name to parse
		*
		* Parse and print information about an XML file.
*/
static gboolean
read_XML_File(const char *filename, GtkWidget *widget) 
{
	GtkWidget *treeview1 = lookup_widget(GTK_WIDGET(widget), "treeview1");
	
	GtkTreeModel *store = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview1));
	gtk_tree_store_clear(GTK_TREE_STORE(store));
	
	xmlTextReaderPtr reader;
	int ret;

	reader = xmlReaderForFile(filename, NULL, 0);
	if (reader != NULL)
	{
		ret = read_ignore_whitespace(reader);
		while (ret == 1) {
			if(!processNode(reader, store))
			{
				return FALSE;
			}
			ret = xmlTextReaderRead(reader);
		}
		xmlTextReaderRead(reader);
		if (ret != 0) {
			fprintf(stderr, "%s : failed to parse\n", filename);
			return FALSE;
		}
	}
	else
	{
		fprintf(stderr, "Unable to open %s\n", filename);
		return FALSE;	
	}
	return TRUE;
}


static gboolean
open_text_file (gchar *filename, GtkWidget *widget)
{
	//printf("Attempting to open file: %s\n", filename);
	
	
	FILE *board; /* declare a FILE pointer  */
	board = fopen(filename, "r");

	/* open byojeopary file for reading */

	if(board==NULL) {
		printf("Error: can't open file.\n");
		return FALSE;
		/* fclose(board); DON'T PASS A NULL POINTER TO fclose !! */
	}
	else {
		//printf("File opened successfully. Contents:\n\n");
		
		GtkWidget *treeview1 = lookup_widget(GTK_WIDGET(widget), "treeview1");
		
		GtkTreeModel *store = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview1));
		gtk_tree_store_clear(GTK_TREE_STORE(store));
		
		char line[4096];  /* declare a char array */
		GtkTreeIter   piter;
		while(fgets(line, 4096, board)!=NULL) { 
			/* keep looping until NULL pointer... */
			//printf("Reading line: %s", line);
			/* print the file one line at a time  */

			if(!strstr(line, ";"))
			{
				//topic
				char topic_str[4096]="";
				sscanf( line, "%[^\n]", &topic_str);
				gtk_tree_store_append (GTK_TREE_STORE(store), &piter, NULL);  /* Acquire an iterator */
				if(strcasecmp(topic_str, "Daily Double")!=0)
				{
					gtk_tree_store_set (GTK_TREE_STORE(store), &piter,
						0, topic_str,
						1, TRUE,
						-1);
				}
				else
				{
					gtk_tree_store_set (GTK_TREE_STORE(store), &piter,
						0, topic_str,
						1, FALSE,
						-1);	
				}
				//printf("Added Topic: %s\n", line);
			}
			else
			{
				char value_str[4096]="";
				char question_str[4096]="";
				char answer_str[4096]="";
				sscanf( line, "%[^;];%[^;];%[^\n]", &value_str, &question_str, &answer_str);
				
				if(strcmp(value_str,"")==0)
				{
					sscanf( line, ";%[^;];%[^\n]", &question_str, &answer_str );			
				}
				if(strcmp(question_str,"")==0 && strcmp(answer_str,"")==0)
				{
					sscanf( line, "%[^;];;%[^\n]", &value_str, &answer_str );
					
				}
				if(strcmp(value_str,"")==0 && strcmp(question_str,"")==0 && strcmp(answer_str,"")==0)
				{
					sscanf( line, ";;%[^\n]", &answer_str );
					
				}
			
				//printf("value:%s\n", &value_str);
				//printf("question:%s\n", &question_str);
				//printf("answer:%s\n", &answer_str);
				add_question(GTK_TREE_STORE(store), piter, value_str, question_str, answer_str);
			}
		}
		//printf("\n\nNow closing file...\n");
		fclose(board);
	}
	return TRUE;
}

gboolean
read_File(gchar *filename, GtkWidget *widget)
{
        if(!read_XML_File(filename, widget))
		{
			printf("Error: Failed to open the file as XML format. Attempting to open file as old text format.");
			if(!open_text_file(filename, widget))
			{
				printf("Error: Failed to open the file as old text format.");
				return FALSE;
			}
		}
		printf("File opened successfully!"); 
		
        GtkWidget *treeview1 = lookup_widget(GTK_WIDGET(widget), "treeview1");
		build_board(treeview1);

		GtkWidget *edit1 = lookup_widget(GTK_WIDGET(widget), "edit1");
		GtkWidget *rebuild_board1 = lookup_widget(GTK_WIDGET(widget), "rebuild_board1");
		gtk_widget_set_sensitive (edit1, TRUE);
		gtk_widget_set_sensitive(rebuild_board1, TRUE);
		byoj_show_board(widget);
		
		current_filename = g_strdup_printf("%s", filename); 

  return TRUE;              
} 

xmlChar *ConvertInput(const char *in, const char *encoding);
void
WriteFile_as_XHTML(const char *uri, GtkWidget *treeview1)
{
	xmlDocPtr doc = WriteDoc_as_XHTML(treeview1);

	xmlSaveFileEnc(uri, doc, MY_ENCODING);

	current_filename = g_strdup_printf("%s", uri);

	xmlFreeDoc(doc);
}
xmlDocPtr
WriteDoc_as_XHTML(GtkWidget *treeview1)
{
	int rc;
	xmlTextWriterPtr writer;
	xmlChar *tmp;
	xmlDocPtr doc;


	/* Create a new XmlWriter for DOM, with no compression. */
	writer = xmlNewTextWriterDoc(&doc, 0);
	if (writer == NULL) {
		printf("testXmlwriterDoc: Error creating the xml writer\n");
		return;
	}
	
/* Start the document with the xml default for the version,
	* encoding ISO 8859-1 and the default for the standalone
* declaration. */
	rc = xmlTextWriterStartDocument(writer, NULL, MY_ENCODING, NULL);
	if (rc < 0) {
		//printf("testXmlwriterFilename: Error at xmlStartDocument\n");
		return;
	}

/* Start an element named "EXAMPLE". Since thist is the first
* element, this will be the root element of the document. */
	rc = xmlTextWriterStartElement(writer, BAD_CAST "byojeopardy");
	if (rc < 0) {
		//printf("testXmlwriterFilename: Error at xmlStartElement\n");
		return;
	}
	/* Add an attribute with name "version" and value "1.0" to ORDER. */
	rc = xmlTextWriterWriteAttribute(writer, BAD_CAST "version",
					BAD_CAST "1.0");
	if (rc < 0) {
		//printf("testXmlwriterFilename: Error at xmlTextWriterWriteAttribute\n");
		return;
	}

	/* Write a comment as child of EXAMPLE.
		* Please observe, that the input to the xmlTextWriter functions
		* HAS to be in UTF-8, even if the output XML is encoded
	* in iso-8859-1 */
	// 	tmp = ConvertInput("This is a comment with special chars: <>",
	// 			MY_ENCODING);
	// 	rc = xmlTextWriterWriteComment(writer, tmp);
	// 	if (rc < 0) {
	// 		//printf
	// 				("testXmlwriterFilename: Error at xmlTextWriterWriteComment\n");
	// 		return;
	// 	}
	// 	if (tmp != NULL) xmlFree(tmp);

	
	GtkTreeModel *store = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview1));

	GtkTreeIter iter;
	gboolean more_topics = gtk_tree_model_get_iter_first (GTK_TREE_MODEL(store), &iter);
	
	while (more_topics) {
		/* Start an element named "topic" as child of byojeopardy. */
		rc = xmlTextWriterStartElement(writer, BAD_CAST "topic");
		if (rc < 0) {
			//printf("testXmlwriterFilename: Error at xmlTextWriterStartElement\n");
			return;
		}
				
		gchar * topic_string;

		gtk_tree_model_get (GTK_TREE_MODEL(store), &iter, 0, &topic_string, -1);
				
		/* Write an element named "topic_name" as child of topic. */
		tmp = ConvertInput(topic_string, MY_ENCODING);
		rc = xmlTextWriterWriteElement(writer, BAD_CAST "topic_name", tmp);
		if (rc < 0) {
			//printf
					("testXmlwriterFilename: Error at xmlTextWriterWriteFormatElement\n");
			return;
		}
		
		int children_count = gtk_tree_model_iter_n_children(GTK_TREE_MODEL(store), &iter);
		int t;
		
		for(t=0; t<children_count; t++){	
			/* Start an element named "value" as child of byojeopardy. */
			rc = xmlTextWriterStartElement(writer, BAD_CAST "value");
			if (rc < 0) {
				//printf
						("testXmlwriterFilename: Error at xmlTextWriterStartElement\n");
				return;
			}
			
			GtkTreeIter value_iter, question_iter;
			gchar * value_string, * question_string, * answer_string;
			gtk_tree_model_iter_nth_child(GTK_TREE_MODEL(store), &value_iter, &iter, t);
			gtk_tree_model_get (GTK_TREE_MODEL(store), &value_iter, 0, &value_string, -1);
			gtk_tree_model_iter_nth_child(GTK_TREE_MODEL(store), &question_iter, &value_iter, 0);
			gtk_tree_model_get (GTK_TREE_MODEL(store), &question_iter, 2, &question_string, -1);
			gtk_tree_model_iter_nth_child(GTK_TREE_MODEL(store), &question_iter, &value_iter, 1);
			gtk_tree_model_get (GTK_TREE_MODEL(store), &question_iter, 2, &answer_string, -1);
	
	
			/* Write an element named "amount" as child of value. */
			tmp = ConvertInput(value_string, MY_ENCODING);
			rc = xmlTextWriterWriteElement(writer, BAD_CAST "amount", tmp);
			if (rc < 0) {
				//printf("testXmlwriterFilename: Error at xmlTextWriterWriteFormatElement\n");
				return;
			}
			/* Write an element named "question" as child of value. */
			tmp = ConvertInput(question_string, MY_ENCODING);
			rc = xmlTextWriterWriteElement(writer, BAD_CAST "question", tmp);
			if (rc < 0) {
				//printf("testXmlwriterFilename: Error at xmlTextWriterWriteFormatElement\n");
				return;
			}
			/* Write an element named "answer" as child of value. */
			tmp = ConvertInput(answer_string, MY_ENCODING);
			rc = xmlTextWriterWriteElement(writer, BAD_CAST "answer", tmp);
			if (rc < 0) {
				//printf("testXmlwriterFilename: Error at xmlTextWriterWriteFormatElement\n");
				return;
			}
			
			/* Close the element named value. */
			rc = xmlTextWriterEndElement(writer);
			if (rc < 0) {
				//printf("testXmlwriterFilename: Error at xmlTextWriterEndElement\n");
				return;
			}
		}
		
		/* Close the element named topic. */
		rc = xmlTextWriterEndElement(writer);
		if (rc < 0) {
			//printf("testXmlwriterFilename: Error at xmlTextWriterEndElement\n");
			return;
		}
		
		more_topics =  gtk_tree_model_iter_next (GTK_TREE_MODEL(store), &iter);
	}
	

/* Here we could close the elements ORDER and EXAMPLE using the
	* function xmlTextWriterEndElement, but since we do not want to
	* write any other elements, we simply call xmlTextWriterEndDocument,
* which will do all the work. */
	rc = xmlTextWriterEndDocument(writer);
	if (rc < 0) {
		printf("XmlwriterFilename: Error at xmlTextWriterEndDocument\n");
		return;
	}

	xmlFreeTextWriter(writer);
	return doc;
}
/**
* ConvertInput:
* @in: string in a given encoding
* @encoding: the encoding used
*
* Converts @in into UTF-8 for processing with libxml2 APIs
*
* Returns the converted UTF-8 string, or NULL in case of error.
*/
xmlChar *
ConvertInput(const char *in, const char *encoding)
{
	xmlChar *out;
	int ret;
	int size;
	int out_size;
	int temp;
	xmlCharEncodingHandlerPtr handler;

	if (in == 0)
		return 0;

	handler = xmlFindCharEncodingHandler(encoding);

	if (!handler) {
		printf("ConvertInput: no encoding handler found for '%s'\n",
		encoding ? encoding : "");
		return 0;
	}

	size = (int) strlen(in) + 1;
	out_size = size * 2 - 1;
	out = (unsigned char *) xmlMalloc((size_t) out_size);

	if (out != 0) {
		temp = size - 1;
		ret = handler->input(out, &out_size, (const xmlChar *) in, &temp);
		if ((ret < 0) || (temp - size + 1)) {
			if (ret < 0) {
				//printf("ConvertInput: conversion wasn't successful.\n");
			} else {
				//printf
						("ConvertInput: conversion wasn't successful. converted: %i octets.\n",
						temp);
			}

			xmlFree(out);
			out = 0;
		} else {
			out = (unsigned char *) xmlRealloc(out, out_size + 1);
			out[out_size] = 0;  /*null terminating out */
		}
	} else {
		//printf("ConvertInput: no mem\n");
	}
	return out;
}



void
on_open1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *FormMain = lookup_widget(GTK_WIDGET(menuitem), "FormMain");
	
GtkWidget *dialog = create_filechooserdialog1 ();
GtkWidget *btnOK = lookup_widget(GTK_WIDGET(dialog), "btnOK");
gtk_button_set_label (GTK_BUTTON(btnOK), "gtk-open");
gtk_button_set_use_stock (GTK_BUTTON(btnOK), TRUE);
gtk_file_chooser_set_action(GTK_FILE_CHOOSER (dialog), GTK_FILE_CHOOSER_ACTION_OPEN);

        GtkFileFilter *filefilter_byj = gtk_file_filter_new();
		gtk_file_filter_set_name(filefilter_byj, "BYOJeopardy (*.byj)");
		 gtk_file_filter_add_pattern(filefilter_byj, "*.byj");
		gtk_file_chooser_add_filter (GTK_FILE_CHOOSER (dialog), filefilter_byj);
		
        GtkFileFilter *filefilter_all = gtk_file_filter_new();
		gtk_file_filter_set_name(filefilter_all, "All Files (*.*)");
		 gtk_file_filter_add_pattern(filefilter_all, "*");
		gtk_file_chooser_add_filter (GTK_FILE_CHOOSER (dialog), filefilter_all);

gtk_file_chooser_set_filename (GTK_FILE_CHOOSER (dialog), current_filename);

gtk_window_set_title(GTK_WINDOW(dialog), "Open File");

	if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_OK)
	{
		gtk_widget_hide(dialog);
		current_filename = g_strdup_printf("");
		gchar *filename;
		filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
		
        read_File(filename, FormMain);
				
		g_free (filename);
//printf("completed opening: %s\n", filename);
	}
	gtk_widget_destroy (dialog);
}


GtkTreeIter 
add_question (GtkTreeStore * store, GtkTreeIter topic_iter, gchar * value_str, gchar * question_str, gchar * answer_str)
{
	GtkTreeIter   value_iter;
	gtk_tree_store_append (store, &value_iter, &topic_iter);  /* Acquire an iterator */
	gtk_tree_store_set (store, &value_iter,
			    0, value_str,
			    1, TRUE,
			    -1);
			
	GtkTreeIter   question_iter;
	gtk_tree_store_append (store, &question_iter, &value_iter);  /* Acquire an iterator */
	gtk_tree_store_set (store, &question_iter,
			    2, question_str,
			    3, TRUE,
			    -1);
	gtk_tree_store_append (store, &question_iter, &value_iter);  /* Acquire an iterator */
	gtk_tree_store_set (store, &question_iter,
			    2, answer_str,
			    3, TRUE,
			    -1);
	return value_iter;
}

GtkTreeIter 
add_daily_double (GtkTreeStore * store, GtkTreeIter topic_iter, gchar * value_str, gchar * question_str, gchar * answer_str)
{
	gtk_tree_store_append (GTK_TREE_STORE(store), &topic_iter, NULL);  /* Acquire an iterator */
	gtk_tree_store_set (GTK_TREE_STORE(store), &topic_iter,
			    0, "Daily Double",
			    1, FALSE,
			    -1);


	GtkTreeIter value_iter = add_question(store, topic_iter, value_str, question_str, answer_str);
	return topic_iter;
}	

void
on_edit1_activate                      (GtkMenuItem     *menuitem,
					gpointer         user_data)
{
	GtkWidget *image1 = lookup_widget(GTK_WIDGET(menuitem), "image1");
	GtkWidget *table1 = lookup_widget(GTK_WIDGET(menuitem), "table1");
	GtkWidget *hboxTreeview = lookup_widget(GTK_WIDGET(menuitem), "hboxTreeview");
	GtkWidget *save1 = lookup_widget(GTK_WIDGET(menuitem), "save1");
	GtkWidget *saveas1 = lookup_widget(GTK_WIDGET(menuitem), "saveas1");
	GtkWidget *export1 = lookup_widget(GTK_WIDGET(menuitem), "export1");
	gtk_widget_set_sensitive (save1, TRUE);
	gtk_widget_set_sensitive(saveas1, TRUE);
	gtk_widget_set_sensitive(export1, TRUE);
	gtk_widget_hide (table1);
	gtk_widget_hide (image1);
	gtk_widget_show (hboxTreeview);
}


void
on_exit1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
gtk_main_quit ();
}


void
on_fullscreen1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *FormMain = lookup_widget(GTK_WIDGET(menuitem), "FormMain");
	if( gtk_check_menu_item_get_active (GTK_CHECK_MENU_ITEM(menuitem)))
{
	//printf("request fullscreen\n");
	gtk_window_fullscreen(GTK_WINDOW(FormMain));
}
else
{
	//printf("request unfullscreen\n");
	gtk_window_unfullscreen(GTK_WINDOW(FormMain));
}
}

void
on_about1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *FormMain = lookup_widget(GTK_WIDGET(menuitem), "FormMain");
			
	GtkWidget * dialog;
	dialog = create_aboutdialog1();
	gtk_window_set_icon(GTK_WINDOW (dialog), gtk_window_get_icon(GTK_WINDOW(FormMain)));
	gtk_dialog_run (GTK_DIALOG (dialog));
}

gboolean
on_FormMain_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
gtk_main_quit ();
return FALSE;
}


void
on_new1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
current_filename = g_strdup_printf("");
GtkWidget *dialog;
dialog = create_DialogTemplate ();
if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_OK)
{
	gtk_widget_hide(dialog);
      printf("ok\n");	
	/*GtkWidget *FormEdit;
	FormEdit = create_FormEdit ();*/

	//Setup list
	GtkWidget *treeview1 = lookup_widget(GTK_WIDGET(menuitem), "treeview1");
	GtkWidget *table1 = lookup_widget(GTK_WIDGET(menuitem), "table1");
	GtkWidget *image1 = lookup_widget(GTK_WIDGET(menuitem), "image1");
	
	GtkTreeModel *store = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview1));
	gtk_tree_store_clear(GTK_TREE_STORE(store));
	
	GtkWidget *rbtnDouble = lookup_widget(GTK_WIDGET(dialog), "rbtnDouble");
	GtkWidget *rbtnNone = lookup_widget(GTK_WIDGET(dialog), "rbtnNone");
	
	gboolean Double = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rbtnDouble));
	gboolean NoTemplate = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rbtnNone));
	if(!NoTemplate)
	{
		fill_template(Double, treeview1);
	}
	build_board(treeview1);
	
	gtk_widget_hide (table1);
	gtk_widget_hide (image1);

	GtkWidget *save1 = lookup_widget(GTK_WIDGET(menuitem), "save1");
	GtkWidget *saveas1 = lookup_widget(GTK_WIDGET(menuitem), "saveas1");
	gtk_widget_set_sensitive (save1, TRUE);
	gtk_widget_set_sensitive(saveas1, TRUE);
	GtkWidget *export1 = lookup_widget(GTK_WIDGET(menuitem), "export1");
	gtk_widget_set_sensitive(export1, TRUE);	
	GtkWidget *edit1 = lookup_widget(GTK_WIDGET(menuitem), "edit1");
	GtkWidget *rebuild_board1 = lookup_widget(GTK_WIDGET(menuitem), "rebuild_board1");
	gtk_widget_set_sensitive (edit1, TRUE);
	gtk_widget_set_sensitive(rebuild_board1, TRUE);

	GtkWidget *hboxTreeview = lookup_widget(GTK_WIDGET(menuitem), "hboxTreeview");
	gtk_widget_show (hboxTreeview);
}
	gtk_widget_destroy(dialog);
}


void
fill_template (gboolean Double_BYOJeopardy, GtkWidget *treeview1)
{
	//printf("Build Template: ");
	
	int value_unit = 100;
	if(Double_BYOJeopardy)
	{
		//printf("Double Selected\n");
		value_unit = 200;
	}
	else
	{
		//printf("Single Selected\n");
	}
	

	GtkTreeModel *store = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview1));
		
	int t;
	GtkTreeIter   piter;
	for(t=1; t<=5; t++)
	{
		gchar * topic_str = g_strdup_printf("Category%d", t);

		gtk_tree_store_append (GTK_TREE_STORE(store), &piter, NULL);  /* Acquire an iterator */
		gtk_tree_store_set (GTK_TREE_STORE(store), &piter,
				0, topic_str,
					1, TRUE,
					-1);
		//printf("Adding Topic: %d\n", t);
		
		int v;
		for(v=1; v<=5; v++)
		{
			int value = v * value_unit;
			gchar *value_str = g_strdup_printf("%d", value);
			gchar *question_str = g_strdup_printf("Question%d", value);
			gchar *answer_str = g_strdup_printf("Answer%d", value);
			
			add_question(GTK_TREE_STORE(store), piter, value_str, question_str, answer_str);
			//printf("Adding Value: %d\n", value);
		}
	}
	printf("Adding Daily Double\n");
	//Daily Double	
	add_daily_double(GTK_TREE_STORE(store), piter, "Topic", "Question", "Answer");
}

void
setup_treeview (GtkWidget *treeview1)
{
	//delete old treeview1 store and columns
	//GtkTreeModel *oldstore = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview1));
	//gtk_tree_store_clear();
	//gtk_widget_destroy(GTK_WIDGET(oldstore));
	//gtk_tree_view_remove_column(GTK_TREE_VIEW(treeview1), gtk_tree_view_get_column(GTK_TREE_VIEW(treeview1),1));
	//gtk_tree_view_remove_column(GTK_TREE_VIEW(treeview1), gtk_tree_view_get_column(GTK_TREE_VIEW(treeview1),0));

	//create new treeview1 store and columns
	GtkTreeStore *store = gtk_tree_store_new (6,
				G_TYPE_STRING,
				G_TYPE_BOOLEAN,
				G_TYPE_STRING,
				G_TYPE_BOOLEAN,
				G_TYPE_STRING,
				G_TYPE_BOOLEAN);
	gtk_tree_view_set_model(GTK_TREE_VIEW(treeview1), GTK_TREE_MODEL(store));
	
	GtkCellRenderer *TopicRender = gtk_cell_renderer_text_new ();
	g_object_set_data (G_OBJECT (TopicRender), "column", 0);
	g_signal_connect (TopicRender, "edited", G_CALLBACK (cell_edited), store);
	GtkTreeViewColumn *TopicCol = gtk_tree_view_column_new ();
	gtk_tree_view_column_set_title(TopicCol, "Topic");
	gtk_tree_view_column_pack_start (TopicCol, TopicRender, TRUE);
	gtk_tree_view_column_add_attribute (TopicCol, TopicRender, "text", 0);
	gtk_tree_view_column_add_attribute (TopicCol, TopicRender, "editable", 1);
	gtk_tree_view_column_set_expand (TopicCol, FALSE);
	gtk_tree_view_column_set_resizable(TopicCol, TRUE);
	gtk_tree_view_column_set_sort_column_id(TopicCol, 0);
	gtk_tree_view_append_column (GTK_TREE_VIEW(treeview1), TopicCol);
	//gtk_tree_view_column_set_reorderable(TopicCol, TRUE);
	//gtk_tree_view_column_set_visible (TopicCol, TRUE);

	GtkCellRenderer *QuestionRender = gtk_cell_renderer_text_new ();
	g_object_set_data (G_OBJECT (QuestionRender), "column", GINT_TO_POINTER(2));
	g_signal_connect(QuestionRender, "edited", (GCallback)cell_edited, store);
	GtkTreeViewColumn *QuestionColumn = gtk_tree_view_column_new ();
	gtk_tree_view_column_set_title(QuestionColumn, "Question / Answer");
	gtk_tree_view_column_pack_start (QuestionColumn, QuestionRender, TRUE);
	gtk_tree_view_column_add_attribute (QuestionColumn, QuestionRender, "text", 2);
	gtk_tree_view_column_add_attribute (QuestionColumn, QuestionRender, "editable", 3);
	gtk_tree_view_column_set_expand (QuestionColumn, TRUE);
	gtk_tree_view_column_set_resizable(QuestionColumn, TRUE);
	gtk_tree_view_column_set_sort_column_id(QuestionColumn, 2);
	gtk_tree_view_append_column (GTK_TREE_VIEW(treeview1), QuestionColumn);

	gtk_tree_view_set_headers_clickable(GTK_TREE_VIEW(treeview1), TRUE);
	//gtk_widget_show_all(treeview1);
}

void
cell_edited (GtkCellRendererText *cell, gchar *path_string, gchar *new_string, gpointer data)
{
	//printf("Cell Edited, %s, %s, %s\n", path_string, new_string, data);
	
	GtkTreeModel *model = (GtkTreeModel *)data;
	GtkTreePath *path = gtk_tree_path_new_from_string (path_string);
	GtkTreeIter iter;

	gint column = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (cell), "column"));
	gtk_tree_model_get_iter (model, &iter, path);
	gtk_tree_store_set (GTK_TREE_STORE (model), &iter, column, new_string, -1);
	gtk_tree_path_free (path);
}

/*
//printf("%s\n", responsestr);
gtk_widget_hide(dialog);
*/

gboolean
on_FormEdit_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
//printf("Closing Edit Window\n");
return FALSE;
}

void
build_board (GtkWidget *widget)
{
	//open dialog and build board
	//Get Format
	GtkWidget *dialog;
	dialog = create_DialogFormat ();
	
	if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_OK)
	{
		gtk_widget_hide(dialog);
		GtkWidget *rbtnFormQuestion = lookup_widget(GTK_WIDGET(dialog), "rbtnFormQuestion");
		AnswerasQuestion = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rbtnFormQuestion));
	}
	gtk_widget_destroy(dialog);
	//build board
	//really a build board method below
    //printf("Start Building Board\n");

	GtkWidget *treeview1 = lookup_widget(GTK_WIDGET(widget), "treeview1");
	GtkWidget *table = lookup_widget(GTK_WIDGET(widget), "table1");
	GtkWidget *image1 = lookup_widget(GTK_WIDGET(widget), "image1");
	GtkWidget *vbox1 = lookup_widget(GTK_WIDGET(widget), "vbox1");
	GtkWidget *hboxTreeview = lookup_widget(GTK_WIDGET(widget), "hboxTreeview");
	GtkTreeModel *store = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview1));

	//find the rows and columns
	int rows = 1;
	int columns = 0;
	int total_blocks_on_board = 0; //for daily double
	gboolean daily_double = FALSE;
	gchar *daily_double_topic;
	gchar *daily_double_question;
	gchar *daily_double_answer;
	// 
	GtkTreeIter iter;
	gboolean more_topics = gtk_tree_model_get_iter_first (GTK_TREE_MODEL(store), &iter);

	while (more_topics) {
		gchar * topic_string;

		gtk_tree_model_get (store, &iter, 0, &topic_string, -1);

		if(topic_string != NULL && strcasecmp(topic_string, "Daily Double")!=0)
		{
			columns += 1;
			int children_count = gtk_tree_model_iter_n_children(store, &iter);
			total_blocks_on_board += children_count; //for daily double
			if (children_count > rows)
			{
				rows = children_count;
			}	
		}
		else
		{
			GtkTreeIter value_iter;
			if(gtk_tree_model_iter_nth_child(GTK_TREE_MODEL(store), &value_iter, &iter, 0))
			{
				GtkTreeIter question_iter;
				gtk_tree_model_get (GTK_TREE_MODEL(store), &value_iter, 0, &daily_double_topic, -1);
				if(gtk_tree_model_iter_nth_child(GTK_TREE_MODEL(store), &question_iter, &value_iter, 0))
				{
					gtk_tree_model_get (GTK_TREE_MODEL(store), &question_iter, 2, &daily_double_question, -1);
				}
				if(gtk_tree_model_iter_nth_child(GTK_TREE_MODEL(store), &question_iter, &value_iter, 1))
				{
					gtk_tree_model_get (GTK_TREE_MODEL(store), &question_iter, 2, &daily_double_answer, -1);
				}
				daily_double = TRUE;
			}
		}
		more_topics =  gtk_tree_model_iter_next (GTK_TREE_MODEL(store), &iter);
	}
	//rebuild table
	gtk_container_foreach (GTK_CONTAINER (table),
			(GtkCallback) gtk_widget_destroy,
			NULL);
	if (columns > 0 && rows > 1)
    {	
	  gtk_table_resize(GTK_TABLE(table), rows, columns);
    }
    else
    {
     //printf("Error opening file: no topics processed\n");
      gtk_widget_hide(table);
      return;  
    }
        
	//get random daily double block
	int daily_double_block = -1; //for no daily double
	if(daily_double)
	{
		/* Set evil seed (initial seed) */
		srand( (unsigned)time( NULL ) );

		daily_double_block = (total_blocks_on_board*(rand() / (RAND_MAX + 1.0))); //find the percent of random number * the total possible
		//printf("Daily Double Block: %d\n", daily_double_block);
	}


	//add buttons to table
	int column = 0;
	int current_block = 0; //for daily double
	more_topics = gtk_tree_model_get_iter_first (GTK_TREE_MODEL(store), &iter);
	while (more_topics) {
		gchar * topic_string;

		gtk_tree_model_get (GTK_TREE_MODEL(store), &iter, 0, &topic_string, -1);
	
	
		if(strcasecmp(topic_string, "Daily Double")!=0)
		{
			GtkWidget *toplabel = gtk_label_new(topic_string);
			printf("making column label: %s\n", topic_string);
			gtk_label_set_markup(GTK_LABEL(toplabel), (gchar *)g_strdup_printf("<b><span size='14000'>%s</span></b>", topic_string));
			gtk_widget_show(toplabel);
			gtk_label_set_line_wrap(GTK_LABEL(toplabel), TRUE);
			gtk_label_set_justify(GTK_LABEL(toplabel), GTK_JUSTIFY_CENTER);
			gtk_widget_set_size_request (toplabel, 125, -1);
			gtk_table_attach(GTK_TABLE(table), toplabel, column, column+1, 0, 1, GTK_EXPAND || GTK_SHRINK, GTK_EXPAND || GTK_SHRINK, 1, 1);
		    
			int children_count = gtk_tree_model_iter_n_children(GTK_TREE_MODEL(store), &iter);
			int t;
		
			for(t=0; t<children_count; t++)
			{	
				//printf("button: %d\n", t);
				GtkTreeIter value_iter, question_iter;
				gchar * value_string, * question_string, * answer_string;
				gtk_tree_model_iter_nth_child(GTK_TREE_MODEL(store), &value_iter, &iter, t);
				gtk_tree_model_get (GTK_TREE_MODEL(store), &value_iter, 0, &value_string, -1);
				gtk_tree_model_iter_nth_child(GTK_TREE_MODEL(store), &question_iter, &value_iter, 0);
				gtk_tree_model_get (GTK_TREE_MODEL(store), &question_iter, 2, &question_string, -1);
				gtk_tree_model_iter_nth_child(GTK_TREE_MODEL(store), &question_iter, &value_iter, 1);
				gtk_tree_model_get (GTK_TREE_MODEL(store), &question_iter, 2, &answer_string, -1);

				GtkWidget *button = gtk_button_new();
				GtkWidget *button_label = gtk_label_new(value_string);
				gtk_container_add(GTK_CONTAINER (button), button_label);
				gtk_label_set_markup(GTK_LABEL(button_label), (gchar *)g_strdup_printf("<span size='30000'>%s</span>", value_string));
			
								
				g_signal_connect ((gpointer) button, "clicked",
						G_CALLBACK (board_button_clicked),
						NULL);
				
				if (current_block == daily_double_block)
				{
					g_object_set_data(G_OBJECT(button), "value", "Daily Double");	
					g_object_set_data(G_OBJECT(button), "topic", daily_double_topic);	
					g_object_set_data(G_OBJECT(button), "daily_double", GINT_TO_POINTER((gboolean)TRUE));
					g_object_set_data(G_OBJECT(button), "question", daily_double_question);
					g_object_set_data(G_OBJECT(button), "answer", daily_double_answer);
				}
				else
				{
					g_object_set_data(G_OBJECT(button), "topic", topic_string);
					g_object_set_data(G_OBJECT(button), "value", value_string);
					g_object_set_data(G_OBJECT(button), "daily_double", GINT_TO_POINTER((gboolean)FALSE));
					g_object_set_data(G_OBJECT(button), "question", question_string);
					g_object_set_data(G_OBJECT(button), "answer", answer_string);
				}

				GtkWidget * eventbox_Button = gtk_event_box_new ();
				gtk_container_add (GTK_CONTAINER (eventbox_Button), button);
				gtk_event_box_set_above_child (GTK_EVENT_BOX (eventbox_Button), TRUE);
				g_signal_connect ((gpointer) eventbox_Button, "button_release_event",
					G_CALLBACK (on_eventbox_button_release_event),
					NULL);
				gtk_widget_show_all (eventbox_Button);
				
				gtk_table_attach_defaults(GTK_TABLE(table), eventbox_Button, column, column+1, t+1, t+2);
			
				current_block +=1;
			}	
			column += 1;
		}
	
		more_topics =  gtk_tree_model_iter_next (GTK_TREE_MODEL(store), &iter);
	}
}


void
on_show_board1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
byoj_show_board(GTK_WIDGET(menuitem));
}

void
board_button_clicked (GtkButton *button)
{
	//printf("button clicked\n");
	gtk_widget_set_sensitive(GTK_WIDGET(button), FALSE);
	
	GtkWidget *FormQuestion;
	FormQuestion = create_FormQuestion ();
	gtk_window_fullscreen(GTK_WINDOW(FormQuestion));
	
	GtkWidget *lbTopic = lookup_widget(GTK_WIDGET(FormQuestion), "lbTopic");
	GtkWidget *lbValue = lookup_widget(GTK_WIDGET(FormQuestion), "lbValue");
	GtkWidget *tv_Question = lookup_widget(GTK_WIDGET(FormQuestion), "tv_Question");
	//GtkWidget *btnQuestion = lookup_widget(GTK_WIDGET(FormQuestion), "btnQuestion");
	GtkWidget *btnlabelQuestion = lookup_widget(GTK_WIDGET(FormQuestion), "btnlabelQuestion");
	
	gchar *markup;

	gchar *topic = g_object_get_data(G_OBJECT(button), "topic");
	gtk_label_set_text(GTK_LABEL(lbTopic), topic);
	markup = g_strdup_printf("<span size='20000' color='#999'>%s</span>", topic);
	gtk_label_set_markup(GTK_LABEL(lbTopic),markup);
			
	gchar *value = g_object_get_data(G_OBJECT(button), "value");
	gtk_label_set_text(GTK_LABEL(lbValue), value);
	markup = g_strdup_printf("<span size='20000' color='#999'>%s</span>", value);
	gtk_label_set_markup(GTK_LABEL(lbValue),markup);
	
	gchar *question = g_object_get_data(G_OBJECT(button), "question");
	g_object_set_data(G_OBJECT(FormQuestion), "question", question);
			
	gchar *answer = g_object_get_data(G_OBJECT(button), "answer");
	g_object_set_data(G_OBJECT(FormQuestion), "answer", answer);
	
	gboolean *daily_double = g_object_get_data(G_OBJECT(button), "daily_double");
	//g_object_set_data(G_OBJECT(FormQuestion), "daily_double", daily_double);

	//printf("question:%s\n", question);
	GtkTextBuffer * textbuffer = create_buffer((GtkTextView *)tv_Question, FALSE);
    gchar * buf;

	if(daily_double)
	{
		markup = g_strdup_printf("<span size='20000' color='#CC3333'>Start Daily Double</span>", value);
		buf = g_strdup_printf("<html><center><byojeopardy_large>Daily Double</byojeopardy_large></center></html>");
	}
	else
	{
		if(AnswerasQuestion==TRUE)
		{
			markup = g_strdup_printf("<span size='20000' color='#333'>Question</span>");
            gchar * relative_size = question_size(answer);
            buf = g_strdup_printf("<html><center><byojeopardy_%s>%s</byojeopardy_%s></center></html>", relative_size, answer, relative_size);
		}
		else
		{
			markup = g_strdup_printf("<span size='20000' color='#333'>Answer</span>");
            gchar * relative_size = question_size(answer);
            buf = g_strdup_printf("<html><center><byojeopardy_%s>%s</byojeopardy_%s></center></html>", relative_size, question, relative_size);
		}
	}
	gtk_label_set_markup(GTK_LABEL(btnlabelQuestion), markup);
	set_XHTML(textbuffer, buf);
	
	gtk_widget_show (FormQuestion);
}

void
on_btnHome_clicked (GtkButton *button, gpointer user_data)
{
GtkWidget *FormQuestion = lookup_widget(GTK_WIDGET(button), "FormQuestion");
gtk_widget_destroy (FormQuestion);
}


void
on_btnQuestion_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *FormQuestion = lookup_widget(GTK_WIDGET(button), "FormQuestion");
	GtkWidget *btnlabelQuestion = lookup_widget(GTK_WIDGET(FormQuestion), "btnlabelQuestion");
	GtkWidget *tv_Question = lookup_widget(GTK_WIDGET(FormQuestion), "tv_Question");

	gchar *question = g_object_get_data(G_OBJECT(FormQuestion), "question");
	gchar *answer = g_object_get_data(G_OBJECT(FormQuestion), "answer");

	const gchar *btnlabel = gtk_label_get_label(GTK_LABEL(btnlabelQuestion));
	gchar * buf, * markup;

	if(strstr(btnlabel, "Answer")!=NULL || strstr(btnlabel, "Start Daily Double")!=NULL && AnswerasQuestion)
	{
		markup = g_strdup_printf("<span size='20000' color='#333'>Question</span>");
		gchar * relative_size = question_size(answer);
    	buf = g_strdup_printf("<html><center><byojeopardy_%s>%s</byojeopardy_%s></center></html>", relative_size, answer, relative_size);
	}
	else
	{
		markup = g_strdup_printf("<span size='20000' color='#333'>Answer</span>");
		gchar * relative_size = question_size(answer);
    	buf = g_strdup_printf("<html><center><byojeopardy_%s>%s</byojeopardy_%s></center></html>", relative_size, question, relative_size);
	}
	gtk_label_set_markup(GTK_LABEL(btnlabelQuestion), markup);
	set_XHTML(GTK_TEXT_VIEW(tv_Question)->buffer, buf);
}

void
on_save1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *treeview1 = lookup_widget(GTK_WIDGET(menuitem), "treeview1");
	save_file(treeview1);
}


void
on_saveas1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *treeview1 = lookup_widget(GTK_WIDGET(menuitem), "treeview1");
	saveas_file(treeview1);
}


void
on_toolbtnSave_clicked (GtkToolButton *toolbutton, gpointer user_data)
{
	GtkWidget *treeview1 = lookup_widget(GTK_WIDGET(toolbutton), "treeview1");
	save_file(treeview1);
}


void
on_toolbtnSaveAs_clicked (GtkToolButton *toolbutton, gpointer user_data)
{
	GtkWidget *treeview1 = lookup_widget(GTK_WIDGET(toolbutton), "treeview1");
	saveas_file(treeview1);
}

void
save_file (GtkWidget *treeview1)
{
	//printf("attempting to save: %s\n", current_filename);
	if(current_filename != NULL && strlen(current_filename)==0)  /*open save as if no file*/
	{
		saveas_file(treeview1);
	}
	else
	{
		WriteFile_as_XHTML(current_filename, treeview1);
	}
}

void
saveas_file	(GtkWidget *treeview1)
{
		GtkWidget *dialog;
		dialog = create_filechooserdialog1 ();
		GtkWidget *btnOK = lookup_widget(GTK_WIDGET(dialog), "btnOK");
		gtk_button_set_label (GTK_BUTTON(btnOK), "gtk-save");
		gtk_button_set_use_stock (GTK_BUTTON(btnOK), TRUE);
		gtk_file_chooser_set_action(GTK_FILE_CHOOSER (dialog), GTK_FILE_CHOOSER_ACTION_SAVE);
		gtk_file_chooser_set_filename (GTK_FILE_CHOOSER (dialog), current_filename);
		
        GtkFileFilter *filefilter_byj = gtk_file_filter_new();
		gtk_file_filter_set_name(filefilter_byj, "BYOJeopardy (*.byj)");
		 gtk_file_filter_add_pattern(filefilter_byj, "*.byj");
		gtk_file_chooser_add_filter (GTK_FILE_CHOOSER (dialog), filefilter_byj);
		
        GtkFileFilter *filefilter_all = gtk_file_filter_new();
		gtk_file_filter_set_name(filefilter_all, "All Files (*.*)");
		 gtk_file_filter_add_pattern(filefilter_all, "*");
		gtk_file_chooser_add_filter (GTK_FILE_CHOOSER (dialog), filefilter_all);
				
        gtk_window_set_title(GTK_WINDOW(dialog), "Save File");

		if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_OK)
		{
			gchar * filename;
			filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
			current_filename = g_strdup_printf("%s", filename);
			//write_file (treeview1);
			//TODO: add chosen file extension if not written already
			
			WriteFile_as_XHTML(filename, treeview1);
			g_free(filename);
		} 
	gtk_widget_destroy (dialog);
}

void
write_file (GtkWidget *treeview1)
{
	//printf("Saving file: %s\n", current_filename);

	FILE *board;
	board = fopen(current_filename, "w");
	if (board!=NULL)
	{
	GtkTreeModel *store = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview1));

	GtkTreeIter iter;
	gboolean more_topics = gtk_tree_model_get_iter_first (GTK_TREE_MODEL(store), &iter);
	
	while (more_topics) {
		gchar * topic_string;

		gtk_tree_model_get (GTK_TREE_MODEL(store), &iter, 0, &topic_string, -1);
		g_strconcat(topic_string, "\n\0");
		fputs (topic_string, board);
		
		int children_count = gtk_tree_model_iter_n_children(GTK_TREE_MODEL(store), &iter);
		int t;
		
		for(t=0; t<children_count; t++){	
			GtkTreeIter ValueIter;
			  /* made need to change this if questions and answers have a lot of formattin*/
			gchar * value_string, * question_string, * answer_string;
			gtk_tree_model_iter_nth_child(GTK_TREE_MODEL(store), &ValueIter, &iter, t);
			gtk_tree_model_get (GTK_TREE_MODEL(store), &ValueIter, 0, &value_string, 2, &question_string, 4, &answer_string, -1);
			
			gchar *value_output = g_strdup_printf("%s;%s;%s\n", value_string, question_string, answer_string);
			fputs (value_output, board);
		}
		more_topics =  gtk_tree_model_iter_next (GTK_TREE_MODEL(store), &iter);
		}
	fclose (board);
	}
} 

void
on_btnEditlb_clicked (GtkToolButton *toolbutton, gpointer user_data)
{
	GtkWidget *treeview1 = lookup_widget(GTK_WIDGET(toolbutton), "treeview1");
	GtkTreeModel *store = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview1));
	GtkTreeSelection * selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview1));
	GtkTreeIter iter;
	if(gtk_tree_selection_get_selected (selection, &store, &iter))
	{
		gchar * question_string;
		gtk_tree_model_get (GTK_TREE_MODEL(store), &iter, 2, &question_string, -1);
		if(question_string!= NULL)
		{
			/*Edit question and answer iters*/
			gtk_tree_selection_unselect_all(selection);
			GtkWidget *dialoglite = create_dialoglite();
			gchar * xml = g_strdup_printf("<html>%s</html>", question_string);
			setup_buffer(dialoglite, xml, FALSE);
			if (gtk_dialog_run (GTK_DIALOG (dialoglite)) == GTK_RESPONSE_OK)
			{
				GtkTextView * textview = GTK_TEXT_VIEW(lookup_widget(GTK_WIDGET(dialoglite), "textview1"));
				gtk_tree_store_set (GTK_TREE_STORE(store), &iter,
						2, WriteXHTML_as_Markup(textview->buffer, "filename"),
						3, TRUE,
						-1);
			}
			gtk_tree_selection_select_iter(selection, &iter);
		}
		else
		{
			/*Edit topic and value iters*/
			gtk_tree_view_set_cursor (GTK_TREE_VIEW(treeview1), gtk_tree_model_get_path(store, &iter),
					gtk_tree_view_get_column (GTK_TREE_VIEW(treeview1), 0),  TRUE);
		}
	}
}


void
on_btnAddTopic_clicked (GtkToolButton *toolbutton, gpointer user_data)
{
	GtkWidget *treeview1 = lookup_widget(GTK_WIDGET(toolbutton), "treeview1");
	GtkTreeModel *store = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview1));
	GtkTreeIter   piter;
	gtk_tree_store_append (GTK_TREE_STORE(store), &piter, NULL);  /* Acquire an iterator */
	gtk_tree_store_set (GTK_TREE_STORE(store), &piter,
			0, "New Topic",
			1, TRUE,
			-1);
	GtkTreeSelection * selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview1));
	gtk_tree_view_scroll_to_cell (GTK_TREE_VIEW(treeview1), gtk_tree_model_get_path(store,&piter), NULL, FALSE, 0.5, 0);
	//gtk_tree_view_expand_row (GTK_TREE_VIEW(view), gtk_tree_model_get_path(model,&iter), TRUE);
	gtk_tree_selection_select_iter (selection, &piter);
	gtk_tree_view_set_cursor (GTK_TREE_VIEW(treeview1), gtk_tree_model_get_path(store, &piter),
		gtk_tree_view_get_column (GTK_TREE_VIEW(treeview1), 0),  TRUE);
}


void
on_btnAddValue_clicked (GtkToolButton *toolbutton, gpointer user_data)
{
	GtkWidget * treeview1 = lookup_widget(GTK_WIDGET(toolbutton), "treeview1");
	GtkTreeModel * store = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview1));
	GtkTreeIter   piter;

	GtkTreeSelection * selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview1));
	if(gtk_tree_selection_get_selected (selection, &store, &piter))
	{
		GtkTreeIter   piter2;
		if(gtk_tree_model_iter_parent(store,  &piter2, &piter))
		{
			piter = piter2;
			if(gtk_tree_model_iter_parent(store,  &piter2, &piter))
			{
				piter = piter2;
			}
		}
		GValue gtopic;
		const gchar *topic;
		memset(&gtopic, 0, sizeof(gtopic));
		gtk_tree_model_get_value(store,
					&piter,
					0, &gtopic);
		topic = g_value_get_string(&gtopic);
		if(strcasecmp(topic, "Daily Double") || gtk_tree_model_iter_n_children (store, &piter)==0)
		{
			GtkTreeIter value_iter = add_question(GTK_TREE_STORE(store), piter, "New Value", "New Question", "New Answer");
			gtk_tree_view_expand_row (GTK_TREE_VIEW(treeview1), gtk_tree_model_get_path(store,&piter), FALSE);
			gtk_tree_view_expand_row (GTK_TREE_VIEW(treeview1), gtk_tree_model_get_path(store,&value_iter), TRUE);
			gtk_tree_view_scroll_to_cell (GTK_TREE_VIEW(treeview1), gtk_tree_model_get_path(store,&value_iter), gtk_tree_view_get_column (GTK_TREE_VIEW(treeview1), 0), TRUE, 0.5, 0);
			gtk_tree_selection_select_iter (selection, &value_iter);
			gtk_tree_view_set_cursor (GTK_TREE_VIEW(treeview1), gtk_tree_model_get_path(store, &value_iter),
					  gtk_tree_view_get_column (GTK_TREE_VIEW(treeview1), 0),  TRUE);
		}
	}
}


void
on_toolbtnAddDaily_clicked (GtkToolButton *toolbutton, gpointer user_data)
{
	GtkWidget *treeview1 = lookup_widget(GTK_WIDGET(toolbutton), "treeview1");
	GtkTreeModel *store = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview1));
	GtkTreeSelection * selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview1));
	
	GtkTreeIter piter;
	gboolean more_topics = gtk_tree_model_get_iter_first (GTK_TREE_MODEL(store), &piter);
	while (more_topics) {
		GValue gtopic;
		const gchar * topic;
		memset(&gtopic, 0, sizeof(gtopic));
		gtk_tree_model_get_value(store,
					&piter,
					0, &gtopic);
		topic = g_value_get_string(&gtopic);
		if(!strcasecmp(topic, "Daily Double"))
		{
			//should not add if there is a label Daily Double
			return ;
		}
		more_topics =  gtk_tree_model_iter_next (GTK_TREE_MODEL(store), &piter);
	}
	GtkTreeIter topic_iter = add_daily_double(GTK_TREE_STORE(store), piter, "New Topic", "New Question", "New Answer");
	gtk_tree_view_expand_row (GTK_TREE_VIEW(treeview1), gtk_tree_model_get_path(store, &topic_iter), TRUE);
	GtkTreeIter value_iter;
	gtk_tree_model_iter_nth_child(store, &value_iter, &topic_iter, 0);
	gtk_tree_view_scroll_to_cell (GTK_TREE_VIEW(treeview1), gtk_tree_model_get_path(store, &value_iter),  gtk_tree_view_get_column (GTK_TREE_VIEW(treeview1), 0), TRUE, 0.5, 0);
	gtk_tree_selection_select_iter (selection, &value_iter);
	gtk_tree_view_set_cursor (GTK_TREE_VIEW(treeview1), gtk_tree_model_get_path(store, &value_iter),
				  gtk_tree_view_get_column (GTK_TREE_VIEW(treeview1), 0),  TRUE);
}


void
on_toolbtnDelete_clicked (GtkToolButton *toolbutton, gpointer user_data)
{
	GtkWidget *treeview1 = lookup_widget(GTK_WIDGET(toolbutton), "treeview1");
	GtkTreeModel *store = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview1));
	GtkTreeSelection * selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview1));
	GtkTreeIter piter;
	if(gtk_tree_selection_get_selected (selection, &store, &piter))
	{
		GtkTreeIter   piter2;
		if(gtk_tree_model_iter_has_child(store, &piter))
		{
			if(gtk_tree_model_iter_parent(store,  &piter2, &piter))
			{
				GValue gtopic;
				const gchar * topic;
				memset(&gtopic, 0, sizeof(gtopic));
				gtk_tree_model_get_value(store,
						&piter2,
						0, &gtopic);
				topic = g_value_get_string(&gtopic);
				if(!strcasecmp(topic, "Daily Double"))
				{
					//printf("yes\n");
					gtk_tree_store_remove(GTK_TREE_STORE(store), &piter2);
					return ;
				}
			}
			gtk_tree_store_remove(GTK_TREE_STORE(store), &piter);
		}
		else
		{
			if(!gtk_tree_model_iter_parent(store,  &piter2, &piter))
			{
				gtk_tree_store_remove(GTK_TREE_STORE(store), &piter);
			}
		}
	}
}


void
on_rebuild_board1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *FormMain = lookup_widget(GTK_WIDGET(menuitem), "FormMain");
	build_board(FormMain);
	byoj_show_board(GTK_WIDGET(menuitem));
}


void
on_button_Restore_Question_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget * button_Table = user_data;
	gtk_widget_set_sensitive(button_Table, TRUE);
}


void
on_button_Close_Question_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	//printf("gotcha\n");
	GtkWidget * button_Table = user_data;
	gtk_widget_set_sensitive(button_Table, FALSE);
}

gboolean
on_eventbox_button_release_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data)
{
	GtkWidget * button_Table = gtk_bin_get_child (GTK_BIN(widget));
	if (event->button == 3)
	{
		//printf("call menu\n");
		GtkWidget *menu = create_menu_Question();
		
		GtkWidget *button_Restore_Question = lookup_widget(GTK_WIDGET(menu), "button_Restore_Question");
		GtkWidget *button_Close_Question = lookup_widget(GTK_WIDGET(menu), "button_Close_Question");
		if(button_Table->state == GTK_STATE_NORMAL)
		{
			gtk_widget_show (button_Close_Question);
			gtk_widget_hide (button_Restore_Question);
			g_signal_connect ((gpointer) button_Close_Question, "activate",
					   G_CALLBACK (on_button_Close_Question_activate),
					button_Table);
		}
		else
		{
			gtk_widget_show (button_Restore_Question);
			gtk_widget_hide (button_Close_Question);
			g_signal_connect ((gpointer) button_Restore_Question, "activate",
					G_CALLBACK (on_button_Restore_Question_activate),
					button_Table);
		}

		gtk_menu_popup (GTK_MENU (menu), NULL, NULL, NULL, NULL,
			event->button, event->time);
	}
	else
	{
		if(button_Table->state == GTK_STATE_NORMAL)
		{
			gtk_button_clicked (GTK_BUTTON(button_Table));
		}
	}
  return FALSE;
}

void
on_export1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	export_dialog(GTK_WIDGET(menuitem));
}
